#include <unistd.h>

#include <time.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"

#include "main.h"
#include "xgrafi.h"
#include "objetos.h"
#include "port.h"


#define TIEMPO1		25
#define TIEMPO2		50
#define TIEMPO3		100


void MiTimer();
int tiempo1=TIEMPO1,tiempo2=TIEMPO2, tiempo3=TIEMPO3;

int  ContadorI=0;
char Binput[100];
char Binput2[10];


Boton *Bexit;
Boton *Bvolmas;
Boton *Bvolmenos;
Boton *Bbuscarmas;
Boton *Bbuscarmenos;
Boton *Bsintoniamas;
Boton *Bsintoniamenos;
Boton *Bextra;

TextoE *Efrecuencia;
TextoE *Ecanal;
TextoE *Edevice;

TextoS *Shercios;
TextoS *Scanal;
TextoS *Snombre;

void Repaint(void);

int SearchPort();
void analizarIN();

int canal=0,frecuencia=1035;


int main (int argc, char *argv[])
{
	int z;
	int quit = 0;
	int mouse_x,mouse_y;
//	Uint8 *teclas; 	
	int SimbolKey;
	
#if YesWindows 
 #if DEBUG
	AllocConsole();
	freopen("CON", "w", stdout); // redirects stdout
	freopen("CON", "w", stderr); // redirects stderr
 #endif
#endif
		
	
	if(init(388,138) == 0 ) return 1;
	
	SDL_FillRect( screen, NULL, SDL_MapRGB( screen->format, 0x42, 0x73, 0x4A ) );
	if( SDL_Flip( screen ) == -1 ) return 3;
	//if (load_files((char*)"modelo2.png",NULL,(char*)"seta.ttf") == 0 ) return 2;
	if (load_files(NULL,NULL,(char*)"setam.ttf") == 0 ) return 2;
		
//_______________________		
	Bexit=new Boton(284,104,89,24,(char*) "EXIT");
	Bvolmas=new Boton(284,72,89,24,(char*) "vol>");
	Bvolmenos=new Boton(192,72,89,24,(char*) "<vol");
	Bsintoniamas=new Boton(100,104,89,24,(char*) ">");
	Bsintoniamenos=new Boton(8,104,89,24,(char*) "<");
	Bbuscarmenos=new Boton(8,72,89,24,(char*) "<<");
	Bbuscarmas=new Boton(100,72,89,24,(char*) ">>");	
	Efrecuencia=new TextoE(8,6,85,24,(char*) "Frecu");
	Ecanal=new TextoE(8,40,85,24,(char*) "Canal");
	Edevice=new TextoE(192,40,175,24,(char*) "no Device");	
	Shercios=new TextoS(100,8,(char*) "MHz");
	Scanal=new TextoS(100,40,(char*) "Canal");
	Snombre=new TextoS(192,5,(char*) "RadioARDU_SDLv");
	Repaint();
	
	z=SearchPort();	
	if(z==-1)
			 { printf("No RADIO %d\n",z);}
			else
		     { 
				MODEMDEVICE=myport[z];
	#if YesWindows
				if(hSerial)CloseRs232();
	#else		
				if(fdrs232)CloseRs232();
	#endif		 
				IniRs232();
				Edevice->Value(MODEMDEVICE);
				Ecanal->Value(canal);
				Efrecuencia->Value(float(frecuencia)/10);	
			 }
	Repaint();
	
//________________________		
	while( quit == 0 )
	{	
		SDL_Delay(20);	  
		MiTimer();								  	  
		while( SDL_PollEvent( &event ) )
		{
//			teclas = SDL_GetKeyState(NULL);
			Ecanal->Value(canal);
			Efrecuencia->Value(float(frecuencia)/10);				
			switch (event.type)			
			{	
				case	SDL_KEYDOWN:
						SimbolKey=event.key.keysym.sym;	
						#ifdef DEBUG 
							printf("Evento Tecla  %d\n",SimbolKey);
						#endif										
						switch (SimbolKey)			
							{				
								case	SDLK_F1:
										#if YesWindows
											screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
										#else
											SDL_WM_ToggleFullScreen(screen);
										#endif  						
										Repaint();
								break;
								case	SDLK_F2:
										screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );						
										Repaint();
								break;
								case	SDLK_ESCAPE:
										quit=1;
								break;
								case	SDLK_r:
										Repaint();
								break;
							}					
				break;
				case	SDL_MOUSEBUTTONDOWN:
					mouse_x=event.button.x;
					mouse_y=event.button.y;				
					#ifdef DEBUG 
						printf("Evento Raton Abajo X=%d Y=%d Nboton=%d\n",mouse_x,mouse_y,event.button.button);	
					#endif
					if(Bexit->get(mouse_x,mouse_y)) 
						{						 
						 quit=1;
						 goto salir1;	
						}
					if(Bvolmas->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("B_vol+\n");
						 #endif
						 PrintSerial((char *)"volume+\n");
						 Bvolmas->DibujarDown();
						 goto salir1;	
						}
					if(Bvolmenos->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("B_vol-\n");
						 #endif
						 PrintSerial((char *)"volume-\n");	
						 Bvolmenos->DibujarDown();
						 goto salir1;	
						}
					if(Bsintoniamas->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("Sintomas\n");
						 #endif
						 if(canal < 210) canal++;
						 sprintf(VARI,"ncanal=%d\n",canal);
						 PrintSerial(VARI); 
						 Bsintoniamas->DibujarDown();
						 goto salir1;	
						}
					if(Bsintoniamenos->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("Sintomenos\n");
						 #endif
						 if(canal>0) canal--;
						 sprintf(VARI,"ncanal=%d\n",canal);
						 PrintSerial(VARI);  
						 Bsintoniamenos->DibujarDown();
						 goto salir1;	
						}
					if(Bbuscarmas->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("Buscarmas\n");
						 #endif
						 PrintSerial((char *)"buscar+\n"); 
						 Bbuscarmas->DibujarDown();
						 goto salir1;	
						}
					if(Bbuscarmenos->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("Buscarmenos\n");
						 #endif
						 PrintSerial((char *)"buscar-\n"); 
						 Bbuscarmenos->DibujarDown();
						 goto salir1;	
						}					
					goto salir12;
salir1:						
					SDL_Flip( screen );
salir12:
				break;
				case	SDL_MOUSEBUTTONUP:
					mouse_x=event.button.x;
					mouse_y=event.button.y;
					
					Repaint();				
					
					#ifdef DEBUG 
						printf("Boton Arriba X=%d Y=%d \n",mouse_x,mouse_y);
					#endif	
				break;
				case	SDL_QUIT:
					quit = 1;
				break;		
			}			
		}
	}
	
//	salir: 
     //Cerrar todo el SDL
    PrintSerial((char *)"volume=0\n");
	clean_up();
#ifdef DEBUG 
		printf("Fin\n");
#endif	
	SDL_Delay(500);
	return 0;  
}

//____________________FIN____________

void Repaint(void)
{
	SDL_WM_SetCaption( "RadioARDU_sdl", NULL );
	apply_surface( 0, 0, background, screen );
	Bexit->Dibujar();
	Bvolmas->Dibujar();
	Bvolmenos->Dibujar();
	Bsintoniamas->Dibujar();
	Bsintoniamenos->Dibujar();	
	Bbuscarmas->Dibujar();
	Bbuscarmenos->Dibujar();
	Efrecuencia->Dibujar();
	Ecanal->Dibujar();
	Edevice->Dibujar();	
	Shercios->Dibujar();	
	Scanal->Dibujar();
	setcolor(253,251,7); Snombre->DibujarColor();										
	SDL_Flip( screen );
}



void MiTimer()
{
 int nbytes;
 
	tiempo1--;	
	tiempo2--;	
	tiempo3--;
// cada __tiempo1	
	if(tiempo1<0)
		{	
			tiempo1=TIEMPO1;
#ifdef DEBUG 
					printf("Tiempo1\n");
#endif

#if YesWindows			
			while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
			while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif			
			{
					//printf("Leer %d -> %s\n",ContadorI,Binput2);	
				Binput[ContadorI]=Binput2[0];
				ContadorI++;
				if (Binput2[0] == '\n')
				{
					if(ContadorI<2)ContadorI=2;   
					Binput[ContadorI-2]=0;
					ContadorI=0;	
#ifdef DEBUG 
					printf("Leidos-> %s\n",Binput);
#endif					
					sprintf(VARI,"%s",Binput);	
					analizarIN();
					Ecanal->Value(canal);
					Efrecuencia->Value(float(frecuencia)/10);	
					Repaint();																	
				}															
			}					
		}


}

//________________________________________
void analizarIN()
{

		if(!strncmp(VARI,"Canal=",6))
		{
			strncpy(Binput2,VARI+6,4);
			canal=atoi(Binput2);	 
#ifdef DEBUG 
			printf("OK_Canal =%d \n",canal);
#endif			
			goto salirpro;
		}
		if(!strncmp(VARI,"Frecuencia=",11)) 
		{
			strncpy(Binput2,VARI+11,4);
			frecuencia=atoi(Binput2);			 
#ifdef DEBUG 
			printf("OK_Frecuencia =%d \n",frecuencia);
#endif		
			goto salirpro;
		}
#ifdef DEBUG 		
		printf("->%s\n",VARI);
#endif		
		salirpro:
		;
}



//______________

int SearchPort()
{
		int z,zz,nbytes;
		
		printf("Search serial\n");
 #if YesWindows
		for (z=0;z<11;z++)
 #else
			for (z=0;z<7;z++)
 #endif		
			{
				MODEMDEVICE=myport[z];
#ifdef DEBUG 
				printf("Port %s\n",MODEMDEVICE);
#endif				
				if(0==IniRs232())
				{               
					DelayMs(1000);
					PrintSerial((char *)"\n\n"); 
					DelayMs(100);
					PrintSerial((char *)"RADIO1=\n");
					DelayMs(100);
					
					ContadorI=0; 
					for(zz=0;zz<10;zz++)
					{
						DelayMs(200);
#if YesWindows
						while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
							while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif		
							{	
							 //if(DEBUG)printf("Leer %d -> %s\n",nbytes,Binput2);
								Binput[ContadorI]=Binput2[0];
								ContadorI++;
								if (Binput2[0] == '\n')
								{
									if(ContadorI<2)ContadorI=2;   
									Binput[ContadorI-1]=0;
									ContadorI=0;	
									sprintf(VARI,"%s",Binput);
                                 //printf("==%s\n",VARI);
									if(!strncmp(VARI,"OK",2))
									{
										printf("Radio found at %s\n",MODEMDEVICE);
										CloseRs232();                                   
										return z;
									}			
								}
							}	  	  
						}             
					}
					CloseRs232();
				}
				printf("Radio no found \n");
				return -1;
}
